<?php

	/* Basic caching functionality  */

	$enable_cache = 1;
	$cache_time = 15;
	$cache_folder = '/home/artik/Projects/FastBlog/cppblog/benchmark/php/cache/';
	
	$id = $_GET['id'];

	if($enable_cache) {
		$zip = strstr($_SERVER['HTTP_ACCEPT_ENCODING'],'gzip');
		$suffix = $zip ? '.html.gz' : '.html';
		$cache_filename = $cache_folder. $id . $suffix;

		if (file_exists($cache_filename) && time() - filemtime($cache_filename) < $cache_time) {
			if($zip)
				header('Content-Encoding: gzip');
			readfile($cache_filename);
			exit();
		}
	}


	if(!is_numeric($id)) {
		header("Status: 404 Not Found");
		exit();
	}

	$conn = mysql_pconnect('localhost','root','root');
	mysql_select_db('cppcms',$conn);
	$result = mysql_query('SELECT title, content FROM posts WHERE id = '. $id);
	$row =  mysql_fetch_array($result,MYSQL_NUM);
	if(!$row) {
		mysql_free_result($result);
		mysql_close($conn);
		header("Status: 404 Not Found");
		exit();
	}
	$title = $row[0];
	$content = $row[1];

	mysql_free_result($result);
	
	$result = mysql_query('SELECT content FROM comments WHERE post_id = '. $id . ' ORDER BY id ASC');
	$row =  mysql_fetch_array($result,MYSQL_NUM);

	/* Start caching */
	if($enable_cache) {
		ob_start();
	}
	include "markdown.php"

?>
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
		<title><?php echo $title; ?></title>
	</head>
	<body>
		<h1><?php echo $title; ?></h1>
		<div id="content">
		<?php echo markdown($content); ?>
		</div>
		<?php 
			if($row) {
				echo "<ul>\n" ;
				while($row) {
					echo '<li>' , markdown($row[0]) , "</li>\n" ;
					$row =  mysql_fetch_array($result,MYSQL_NUM);
				}
				echo '</ul>' ;
			}
			mysql_free_result($result);
			mysql_close($conn);
		?>
	</body>
</html>
<?php
	/* Complete cache and save it */
	if($enable_cache) {
		$contents = ob_get_contents();
		if($zip) { 
			$encoded = gzencode($contents);
			file_put_contents($cache_filename, $encoded);
			ob_end_clean();
			header('Content-Encoding: gzip');
			echo $encoded;
			exit();
		}
		else {
			file_put_contents($cache_filename, $contents);
			ob_end_flush();
		}
	}

?>
